当前位置:编程学习 > JAVA >>

Java异常的概念和分类

java异常是java提供的用于处理程序中错误的一种机制。
所谓错误是指在程序运行的过程中发生的一些异常事件(如:除0溢出,数组下标越界,所要读取的文件不存在)。
设计良好地程序应该在程序异常发生时提供处理这些错误的方法,使得程序不会因为异常的发生而阻断或产生不可预见的结果。
Java程序的执行过程中如出现异常事件,可以生成一个异常类对象,该异常对象封装了异常事件的信息,并将被提交给java运行时系统,这个过程称为抛出(throw)异常。
当Java运行时系统接收到异常对象时,会寻找能处理这一异常的代码并把当前异常对象交给其处理,这一过程称为捕获(catch)异常。

try里面放的是有可能发生错误的语句,catch里面放的是发生异常之后采取的措施。

异常的分类:
Error:称为错误,由Java虚拟机生成并抛出,包括动态链接失败,虚拟机错误等,程序对其不做处理。
Exception:所有异常类的父类,其子类对应了各种各样的可能出现的异常事件,一般需要用户显示的声明或捕获。
Runtime Exception:一类特殊的异常,如被0除、数组下标超范围等,其产生比较频繁,处理麻烦,如果显示的声明或捕获将会对程序可读性和运行效率影响很大。因此由系统自动检测并将它们交给缺省的异常处理程序(用户可不必对其处理)。

 
其实异常部分主要讲的就是五个关键字:try、catch、finally、throw、throws。
try语句:
try{……}语句制定了一段代码,这段代码就是一次铺货并处理例外的范围。在执行过程中,该段代码可能会产生并抛出一种或几种类型的异常对象,它后面的catch语句要分别对这些异常做相应的处理。如果没有例外发生,所有的catch代码段都被略过不执行。
catch语句:
在catch语句块中是对异常进行处理的代码,每个try语句块可以伴随一个或多个catch语句,用于处理可能产生的不同类型的异常对象。
在catch中声明的异常对象(catch(SomeException e))封装了异常事件发生的信息,在catch语句块中可以使用这个对象的一些方法获取这些信息。
例如:getMessage()方法,用来得到有关异常事件的信息。
            printStackTrace()方法,用来跟踪异常事件发生时执行堆栈的内容。
finally语句:
finally语句为异常处理提供一个统一的出口,使得在控制流程转到程序的其他部分以前,能够对程序的状态做统一的管理。
无论try所指定的程序块中是否抛出例外,finally所指定的代码都要执行。
通常在finally语句中可以进行资源的清除工作,如:
    1.关闭打开的文件
    2.删除临时文件
    3.……
其中throw和throws的区别:
1、throws关键字通常被应用在声明方法时,用来指定可能抛出的异常。多个异常可以使用逗号隔开。当在住函数中调用该方法时,如果发生异常,就会将异常抛给指定异常对象。
例如:
[java] 
<span style="font-size:18px;">public class test { 
    static void pop() throws NegativeArraySizeException{ 
        //定义方法并抛出NegativeArraySizeException 
        int[] arr=new int[-3];//创建数组 
    } 
    public static void main(String[] args)//主方法 
    { 
        try{ 
            pop();//调用pop()方法 
        }catch(NegativeArraySizeException e){ 
            System.out.println("pop()方法抛出的异常");//输出异常信息 
        } 
    } 
}</span> 
2、throw关键字通常用在方法体中,并且抛出一个异常对象。程序在执行到throw语句时立即停止,它后面的语句都不执行。通常throw抛出异常后,如果想在上一级代码中来捕获并处理异常,则需要在抛出异常的方法中使用throws关键字在方法声明中指明要抛出的异常;如果要捕获throw抛出的异常,则必须使用try{}catch{}语句。
例如:
[java] 
<span style="font-size:18px;">public class MyException extends Exception{//创建自定义异常类 
        String message;//定义String类型变量 
        public MyException(String ErrorMessage){//父类方法 
            message=ErrorMessage; 
        } 
        public String getMessage()//覆盖getMessage()方法 
        { 
            return message; 
        } 
    } 
 
 
    public class Captor {//创建类 
    static int quotient(int x,int y) throws MyException{ 
        if(y<0){//判断参数是否小于0 
            throw new MyException("除数不能使负数");//异常信息 
        } 
        return x/y;//返回值 
    } 
     
    public static void main(String[] args)//主方法 
    { 
        try{ 
            int result=quotient(3,-1); 
        }catch(MyException e){//处理自定义异常 
            System.out.println(e.getMessage());//输出异常信息 
        }catch(ArithmeticException e){ 
            //输出ArithmeticException算术异常 
            System.out.println("除数不能为0");//输出提示信息 
        }catch(Exception e){//处理其他异常 
            System.out.println("程序发生了其他异常"); 
        } 
    } 
}</span> 

异常的其他问题:


注:上图灰色部分为打印出来的堆栈错误信息
 
声明并抛出异常:
重写方法需要抛出与原方法所抛出异常类型一致异常或不抛出异常。


 
自定义异常:
使用自定义异常一般有如下步骤:
1、通过继承java.lang.Exception类声明自己的异常类。
2、在方法适当的位置生成自定义异常的实例,并用throw语句抛出。
3、在方法的声明部分用throws语句声明该方法可能抛出的异常。
 

 

 
异常总结:
    1、一个图
    2、五个关键字
    3、先捕获小的异常,在捕获大的异常
    4、异常和重写的关系


补充:软件开发 , Java ,
CopyRight © 2012 站长网 编程知识问答 www.zzzyk.com All Rights Reserved
部份技术文章来自网络,